﻿Imports System
Imports System.Collections
Imports System.Configuration
Imports System.Data
Imports System.Linq
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Xml.Linq

Partial Class ShowPoliciesAndClaimsLinq
    Inherits System.Web.UI.Page

    ' we will be using the LINQ to SQL generated data context
    Private insuranceDB As DataClassesDataContext = New DataClassesDataContext()

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        ' No error message to display 
        DatabaseError.Text = ""
    End Sub

    Protected Sub PoliciesView_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        If PoliciesView.SelectedRow Is Nothing Then
            ' Don't dislay any edit/new claim dialog 
            ChangeClaimView.ActiveViewIndex = -1
        Else
            ' a policy has been selected by the user 
            ChangeClaimView.ActiveViewIndex = 1
            ' get the policy ID of the selected policy
            Dim polID As Integer = CInt(PoliciesView.SelectedValue)
            Dim polType As String = _
               (From policy In insuranceDB.policies Where policy.policyID = polID _
               Select policy.type).Single()

            Dim today As DateTime = System.DateTime.Today

            Dim newRef As String = polType.Substring(0, 1).ToUpper() + _
                today.Year.ToString() + "-" + polID.ToString("00") + "-" + _
                System.DateTime.Now.Millisecond.ToString("000")

            ' initialise claim date and reference 
            reference.Text = newRef
            claimDate.Text = today.ToShortDateString()
        End If
    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' Only go ahead if validation has succeeded 
        If Page.IsValid() = True Then
            Dim newClaim As claim = New claim()
            newClaim.claimDate = System.DateTime.Parse(claimDate.Text)
            newClaim.reference = reference.Text
            newClaim.description = description.Text
            newClaim.amount = Convert.ToDecimal(amount.Text)
            newClaim.policyID = CInt(PoliciesView.SelectedValue)
            newClaim.approved = "N"

            Try
                DatabaseError.Text = ""
                insuranceDB.claims.InsertOnSubmit(newClaim)
                insuranceDB.SubmitChanges()
                ' refresh view of claims, and remove new claim dialog
                ClaimsView.DataBind()
                ChangeClaimView.ActiveViewIndex = -1
            Catch myEx As Exception
                DatabaseError.Text = "Database insertion failed." + myEx.Message
            End Try
        End If
    End Sub

    Protected Sub ClaimsView_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        If ClaimsView.SelectedRow Is Nothing Then
            ChangeClaimView.ActiveViewIndex = -1
        Else
            ' show edit claim dialog
            ChangeClaimView.ActiveViewIndex = 0
        End If
    End Sub

    Protected Sub FormView1_ItemUpdated(ByVal sender As Object, ByVal e As FormViewUpdatedEventArgs)
        If e.Exception Is Nothing Then
            If e.AffectedRows = 1 Then
                DatabaseError.Text = ""
            Else
                DatabaseError.Text = "Rows affected: " + e.AffectedRows.ToString()
            End If
        Else
            DatabaseError.Text = "Database update failed. " + e.Exception.Message
        End If
        ClaimsView.DataBind()
        ChangeClaimView.ActiveViewIndex = -1
    End Sub

End Class
